<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"] ?: array()) + array("_ef2948c87ef38aab9226e41189b" . "29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCB" . "XSEVSRSBvYmplY3RfY29kZSBlcTpzdH" . "I6Y29kZQ=="), "_3cda3f34a" . "da928e4aa3" . "9d4629c550" . "4aa" => base64_decode("aW50OnJpZ2h0cw=" . "="), "_80fc2a45acd015" . "0df87d1fb728940" . "a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wg" . "V0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUg" . "QU5EIHVzZXJfaWQ9aW50OnVpZA=="), "_dbbe14f567693" . "a631f8a43b65af" . "917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFiYXNlOiBvYmplY3QgY29kZSBub3Qgc3BlY2lma" . "WVk"), "_a8b22fedb2" . "7a11e07f5bb" . "9a7c73608ea" => base64_decode("c3RyKDEwMCk6b" . "2JqZWN0X2NvZG" . "U="), "_b06968b9268deaf3b380bd0f" . "e922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlc" . "l9pZD1pbnQ6dWlk"), "_84718d828d2acc3c366f9" . "6b07e841f6a" => base64_decode("YWNsLnNpbXBsZQ" . "=="), "_a7ed4d7" . "408bb99b" . "87a09d89" . "d4212d5d" . "e" => base64_decode("c2ltcGxlX2Fj" . "bA=="), "_c95cbc316178c97697a40" . "3f4d9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBs" . "ZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNv" . "ZGU="), "_27de5a45db71" . "bf24058769b61" . "b3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vd" . "CBzcGVjaWZpZWQ="), "_938704c4c0169c3804d4bd6aa9941a7" . "6" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG" . "9iamVjdCBjb2RlIG5vdCBz" . "cGVjaWZpZWQ="), "_0877a0b48cf4" . "24a0de57a453c" . "e95e30c" => base64_decode("aW50OnV" . "zZXJfaW" . "Q="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_84718d828d2acc3c366f96b07e841f" . "6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_80fc2a45acd0" . "150df87d1fb72" . "8940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_a7ed4d7408bb99b87a" . "09d89d4212d5de"], [$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_a8b22fed" . "b27a11e07" . "f5bb9a7c7" . "3608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_0877a0b48cf424a0de57a45" . "3ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_3cda3f34ada928e4aa39d4629" . "c5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_b06968b" . "9268deaf" . "3b380bd0" . "fe922b45" . "3"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_938704c4c0" . "169c3804d4b" . "d6aa9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_c95cbc316178c9" . "7697a403f4d9124" . "106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_27de5a45d" . "b71bf24058" . "769b61b397" . "5a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_dbbe14f567693a631f8" . "a43b65af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_ef2948c87ef38a" . "ab9226e41189b29" . "ca7"], $acl->GetObjectCode());
    }
}